//------------------------------------------------------------
#ifndef ONEWIRE_H
#define ONEWIRE_H
//------------------------------------------------------------
#include "usb.h"
#include <inttypes.h>
//------------------------------------------------------------
class OneWire_t : public usb_t
{
public:
    OneWire_t(uint16_t VID, uint16_t PID) : usb_t(VID, PID) {}
    OneWire_t(char *path) : usb_t(path) {}
    ~OneWire_t() {}

protected:
    bool OW_RESET();
    bool OW_READ_BIT(uint8_t *B);
    bool OW_READ_2BIT(uint8_t *B);
    bool OW_READ_BYTE(uint8_t *B);
    bool OW_READ_4BYTE(uint32_t *B);
    bool OW_WRITE_BIT(uint8_t B);
    bool OW_WRITE_BYTE(uint8_t B);
    bool OW_WRITE_4BYTE(uint32_t B);
};
//------------------------------------------------------------
#endif // ONEWIRE_H
//------------------------------------------------------------
