//------------------------------------------------------------
#ifndef USB_H
#define USB_H
//------------------------------------------------------------
#include "hidapi.h"
#include <string>
#include <inttypes.h>
//------------------------------------------------------------
#define USB_T_PRODUCT_STR_MAX_SIZE			10
#define USB_T_RX_TX_BUF_SIZE				9
//------------------------------------------------------------
class usb_t
{
protected:
    usb_t(uint16_t VID, uint16_t PID);        //  Напрямую через VID, PID
    usb_t(char *hid_device_path);   //  Через hid_enumerate
    ~usb_t();
//---
private:
    hid_device      *handle;
    uint32_t        Device_ID;          							//  уникальный номер устройства
    wchar_t         Product_String[USB_T_PRODUCT_STR_MAX_SIZE];		//  имя устройства
//---
protected:
    uint8_t         USB_BUFI [USB_T_RX_TX_BUF_SIZE];  //  буфер приёма
    uint8_t         USB_BUFO [USB_T_RX_TX_BUF_SIZE];  //  буфер передачи
//---
protected:
    void USB_BUF_CLEAR();
    bool USB_GET_FEATURE();
    bool USB_SET_FEATURE();
    bool USB_GET_PORT(uint8_t *PS);
    bool USB_SET_PORT(uint8_t PS);
    bool USB_GET_FAMILY(uint8_t *FAMILY);
    bool USB_GET_SOFTV(uint16_t *SV);
    bool USB_GET_ID(uint32_t *ID);
    bool USB_EE_RD(uint8_t ADR, uint8_t *DATA);
    bool USB_EE_WR(uint8_t ADR, uint8_t DATA);
//---
public:
    bool CHECK_HANDLE();
    static void Sleep(int ms);
    uint32_t Get_Device_ID (void);
    void Read_Device_Production_String (std::wstring &wString);
};
//------------------------------------------------------------
#endif // USB_H
//------------------------------------------------------------
